import type { ValueOf } from "../internal/types";
export declare const ChainId: {
    readonly ETH: 1;
    readonly OPTIMISM: 10;
    readonly CRONOS: 25;
    readonly BSC: 56;
    readonly POLYGON: 137;
    readonly FANTOM: 250;
    readonly BOBA: 288;
    readonly METIS: 1088;
    readonly MOONBEAM: 1284;
    readonly MOONRIVER: 1285;
    readonly ARBITRUM: 42161;
    readonly AVALANCHE: 43114;
    readonly DFK: 53935;
    readonly AURORA: 1313161554;
    readonly HARMONY: 1666600000;
};
export declare type ChainId = ValueOf<typeof ChainId> | number;
export declare type ChainIdTypeMap<T> = {
    [k in ChainId]?: T;
};
export declare function supportedChainIds(): number[];
export declare const EIP1559Chains: ChainIdTypeMap<boolean>;
export declare function chainSupportsEIP1559(chainId: number): boolean;
