import type { Token } from "../token";
import { Bridge } from "../bridge/bridge";
import type { ActionHook, ApproveActionHook, ContractTransactionHook, AllowanceHook, NeedsApprovalHook, UseApproveHook } from "./types";
import type { BigNumberish } from "@ethersproject/bignumber";
declare function useCalculateBridgeSwapOutput(args: {
    ethereum: any;
    chainId: number;
    tokenFrom: Token;
    tokenTo: Token;
    amountFrom: BigNumberish;
    chainIdTo: number;
}): ActionHook<Bridge.BridgeOutputEstimate>;
declare function useExecuteBridgeSwap(args: {
    ethereum: any;
    chainId: number;
    tokenFrom: Token;
    tokenTo: Token;
    amountFrom: BigNumberish;
    amountTo: BigNumberish;
    chainIdTo: number;
    addressTo?: string;
}): ContractTransactionHook;
declare function useApproveBridgeSwap(args: {
    ethereum: any;
    chainId: number;
    token: Token;
    amount?: BigNumberish;
}): ApproveActionHook;
declare function useBridgeAllowance(args: {
    ethereum: any;
    chainId: number;
    token: Token;
}): AllowanceHook;
declare function useNeedsBridgeSwapApproval(args: {
    ethereum: any;
    chainId: number;
    token: Token;
    amount: BigNumberish;
}): NeedsApprovalHook;
declare function useBridgeSwapApproval(args: {
    ethereum: any;
    chainId: number;
    token: Token;
    amount: BigNumberish;
}): UseApproveHook;
export { useApproveBridgeSwap, useExecuteBridgeSwap, useCalculateBridgeSwapOutput, useBridgeAllowance, useNeedsBridgeSwapApproval, useBridgeSwapApproval };
