import type { ChainIdTypeMap } from "../common/chainid";
import type { StringMap } from "../common/types";
import type { Provider } from "@ethersproject/providers";
import { Web3Provider } from "@ethersproject/providers";
import { MiniRpcProvider } from "./minirpc";
import { AbstractConnector } from "@web3-react/abstract-connector";
interface RpcConnectorArgs {
    urls: StringMap;
    batchInterval?: number;
}
export declare class RpcConnector {
    protected _providers: ChainIdTypeMap<MiniRpcProvider>;
    protected _web3Providers: ChainIdTypeMap<Web3Provider>;
    protected _chainEndpoints: {
        [chainId: number]: string;
    };
    constructor(args: RpcConnectorArgs);
    provider(chainId: number): Provider;
    private _newProvider;
}
export interface NetworkConnectorArgs {
    urls: ChainIdTypeMap<string>;
    defaultChainId: number;
}
export declare class NetworkConnector extends AbstractConnector {
    currentChainId: number;
    providers: ChainIdTypeMap<MiniRpcProvider>;
    constructor(args: NetworkConnectorArgs);
    get provider(): MiniRpcProvider;
    activate(): Promise<{
        provider: MiniRpcProvider;
        chainId: number;
        account: any;
    }>;
    getProvider(): Promise<MiniRpcProvider>;
    getChainId(): Promise<number>;
    getAccount(): Promise<any>;
    deactivate(): void;
}
export {};
